package com.github.jchanghong

import org.gradle.api.Project
import org.gradle.plugins.signing.SigningPlugin


internal fun addPlugin(project: Project, myExtension: JchPluginExtension) {
    log2("addPlugin()", project, myExtension.logInfo)
    project.pluginManager.withPlugin("java") {
        setPlugin_java(project, myExtension)
        log2("has java plugin, add DependencyManagementPlugin kotlin dokka", project, myExtension.logInfo)
        project.pluginManager.apply(io.spring.gradle.dependencymanagement.DependencyManagementPlugin::class.java)
        project.pluginManager.apply(org.jetbrains.kotlin.gradle.plugin.KotlinPluginWrapper::class.java)
        project.pluginManager.apply(org.jetbrains.kotlin.allopen.gradle.SpringGradleSubplugin::class.java)
        project.pluginManager.apply(org.jetbrains.kotlin.noarg.gradle.KotlinJpaSubplugin::class.java)
        project.pluginManager.apply(org.jetbrains.dokka.gradle.DokkaPlugin::class.java)
        setPlugin_kotlin(project, myExtension)
    }
    project.pluginManager.withPlugin("java-library") {
        log2("has plugin java-library add SigningPlugin", project, myExtension.logInfo)
        setPlugin_java_library(project, myExtension)
        project.pluginManager.apply(SigningPlugin::class.java)
    }
    project.pluginManager.withPlugin("application") {
        log2("has application plugin ,add SpringBootPlugin", project, myExtension.logInfo)
        project.pluginManager.apply(org.springframework.boot.gradle.plugin.SpringBootPlugin::class.java)
    }
    project.pluginManager.withPlugin("maven-publish") {
        setPlugin_maven_publish(project, myExtension)
        log2("has plugin maven-publish add MavenPublishNexusStagingPlugin,sign", project, myExtension.logInfo)
        project.pluginManager.apply(name.remal.gradle_plugins.plugins.publish.nexus_staging.MavenPublishNexusStagingPlugin::class.java)
    }
    project.pluginManager.withPlugin("name.remal.maven-publish-nexus-staging") {
        project.tasks.findByName("releaseNexusRepositories")!!.dependsOn("publish")
        log2("project.tasks.findByName(\"releaseNexusRepositories\")!!.dependsOn(\"publish\")", project, myExtension.logInfo)
    }

}