package com.github.jchanghong.hikcomponent

import cn.hutool.core.io.FileTypeUtil
import cn.hutool.core.io.file.FileNameUtil
import com.github.jchanghong.log2
import org.gradle.api.Project
import java.io.File

object FileUtils {
    /** 对dir目录下所有文件 ，执行替换操作 ！！*/
    fun replaceInDir(project: Project, dir: File, old: String, news: String): Unit {
        dir.walkTopDown().forEach {
            if (it.isFile && it.exists()) {
                replaceFile(project, it, old, news)
            }

        }
    }

    fun replaceFile(project: Project, file: File, old: String, news: String): Unit {
        if (FileNameUtil.extName(file) == "jar") return
        if ((file.length()/1024)>10000) return
        if (FileTypeUtil.getType(file) in setOf("jar","zip")) return
        val readText = file.readText(Charsets.UTF_8)
        val replace = readText.replace(old, news,false).replace("\r\n", "\n",false)
        file.writeText(replace, Charsets.UTF_8)
        log2(file.absolutePath+"  replaceFile $old to $news", project, true)
    }
}