package com.github.jchanghong

import cn.hutool.core.io.resource.ResourceUtil
import org.gradle.api.Project
import org.gradle.plugins.signing.SigningExtension
import org.springframework.boot.gradle.plugin.SpringBootPlugin


val readUtf8Str = ResourceUtil.readUtf8Str("asc.asc")


/** 签名插件设置*/
internal fun setPropertie(project: Project, myExtension: JchPluginExtension) {
    project.pluginManager.withPlugin("signing") {
        project.extensions.findByType(SigningExtension::class.java)?.let {
            it.useInMemoryPgpKeys(readUtf8Str, "123buyaodaohao")
            log2("set signing key ", project, myExtension.logInfo)
        }
    }
}

internal fun getspringBootVersion(project: Project): String {
    var bootversion =
            SpringBootPlugin.BOM_COORDINATES.removePrefix("org.springframework.boot:spring-boot-dependencies:")
    val property = project.findProperty("spring.boot.version")?.toString() ?: ""
    if (property.isNotBlank()) {
        bootversion = property
        log2("spring boot version is: $bootversion", project, true)
    } else {
        log2("spring boot version is: $bootversion change by add property : spring.boot.version", project, true)
    }
    return bootversion
}

internal fun jchspringBootVersion(project: Project): String {
    var bootversion =
            SpringBootPlugin.BOM_COORDINATES.removePrefix("org.springframework.boot:spring-boot-dependencies:")
    val property = project.findProperty("spring.boot.version")?.toString() ?: ""
    if (property.isNotBlank()) {
        bootversion = property
        log2("spring boot version is: $bootversion", project, true)
    } else {
        log2("spring boot version is: $bootversion change by add property : spring.boot.version", project, true)
    }
    return bootversion
}

internal fun jchspringCloudVersion(project: Project): String {
    var cloudVersion = "2020.0.1"
    val property = project.findProperty("spring.cloud.version")?.toString() ?: ""
    if (property.isNotBlank()) {
        cloudVersion = property
        log2("spring cloud version is: $cloudVersion", project, true)
    } else {
        log2("spring cloud version is: $cloudVersion change by property : spring.cloud.version", project, true)
    }
    return cloudVersion
}

internal fun jchKotlinVersion(project: Project): String {
    var kotlinversion = "1.4.30"
    val property = project.findProperty("kotlin.version")?.toString() ?: ""
    if (property.isNotBlank()) {
        kotlinversion = property
        log2("kotlin version is: $kotlinversion", project, true)
    } else {
        log2("kotlin version is: $kotlinversion change by property : kotlin.version", project, true)
    }
    return kotlinversion
}