package com.github.jchanghong

import cn.hutool.core.io.FileUtil
import cn.hutool.core.io.file.FileNameUtil
import org.gradle.api.Project
import java.io.File

fun windows10fileAutoFenlei(project: Project) {
    for (root in File.listRoots()) {
        project.logger.quiet(root.absolutePath)
        val file = File(root, "windows文件自动分类")
        FileUtil.del(file)
        main2(root, project)
    }
}

fun main2(root: File, project: Project) {
    val extNot = setOf(
            "js",
            "class",
            "kt",
            "java",
            "sha1",
            "pom",
            "jar",
            "png",
            "ts",
            "xml",
            "map",
            "json",
            "dll",
            "py",
            "log",
            "idx",
            "md",
            "dat",
            "jx3dat",
            "ftl",
            "properties",
            "html",
            "css",
            "ini",
            "cfg",
            "torrent",
            "st",
            "gif",
            "bin",
            "c",
            "h",
            "ttf",
            "repositories",
            "flow",
            "lua",
            "yml",
            "cab",
            "sh",
            "o",
            "pak",
            "key",
            "webp",
            "npmignore",
            "jsp",
            "tcl",
            "bat"
    )
    val extCfilename =
            setOf("C:\\PerfLogs", "C:\\Program Files", "C:\\Program Files (x86)", "C:\\Recovery", "C:\\Windows")
    val extdoc = setOf("docx", "doc", "xlsx", "xls", "pptx", "ppt", "pdf", "txt")
    val extyzsuo =
            setOf("a", "ar", "zz", "zipx", "zip", "7z", "ace", "bz", "gz", "gzip", "kz", "rar", "tar", "tgz", "iso")
//    val root = File("D:\\test")
    val map = mutableMapOf<String, Long>()
    root.walkTopDown().onEnter {
        it.diroctoryShouldHandle(extCfilename)
    }.forEach {
        if (it.isDirectory) return@forEach
        val ext = FileNameUtil.extName(it)
        if (ext.isNullOrBlank()) return@forEach
        if (ext in extNot) return@forEach
        val subSequence = it.absolutePath.substring(0, 2)
        val subSequence2 = it.absolutePath.substring(2)
        val type = when (ext) {
            in extdoc -> "文档"
            in extyzsuo -> "压缩文件"
            else -> "其他"
        }
        if (type == "其他") {
            return@forEach
        }
        val newfile = """${subSequence}\windows文件自动分类\${type}${subSequence2}"""
        project.logger.quiet(it.absolutePath)
//        println(newfile)
        val orDefault = map.getOrDefault(ext, 0)
        map.put(ext, orDefault + 1)
        runCatching { FileUtil.copy(it.absolutePath, newfile, true) }
    }
}

/** 是目录，但是不处理*/
fun File.diroctoryShouldHandle(extCfilename: Set<String>): Boolean {
    val list = this.list() ?: return false
    if (list.isEmpty()) return false
    if (this.name == "windows文件自动分类") return false
    if (this.absolutePath in extCfilename) {
        return false
    }
    if (this.name.equals("${'$'}RECYCLE.BIN", true)) return false
    if (".git" in list) return false
    if (".gradle" in list) return false
    if (".idea" in list) return false
    if (".mvn" in list) return false
    if ("mvnw.cmd" in list) return false
    if ("gradlew.bat" in list) return false
    if ("postgresql.auto.conf" in list) return false
    if ("XLauncher.exe" in list) return false
    if (".gitignore" in list) return false
    if ("pom.xml" in list && "src" in list) return false
    return true
}