package com.github.jchanghong

import cn.hutool.core.io.FileUtil
import cn.hutool.core.io.file.FileNameUtil
import cn.hutool.core.io.resource.ResourceUtil
import cn.hutool.core.util.ZipUtil
import org.gradle.api.Project
import java.io.File

fun winsw(project: Project): Unit {
    val task = project.tasks.findByName("bootDistZip") ?: return
    project.logger.quiet("开始处理...")
    val bootzip = task.outputs.files?.files?.firstOrNull() ?: return
    project.logger.quiet(bootzip.absolutePath)
    val nameandversion = FileNameUtil.getPrefix(bootzip)
    var onlyname = nameandversion
    val xml = ResourceUtil.readUtf8Str("winsw/winsw.xml")
    val exe = ResourceUtil.getStream("winsw/winsw.exe")
    FileUtil.del(bootzip.absolutePath.removeSuffix(".zip"))
    if (project.version != null) {
        onlyname = onlyname.removeSuffix("-${project.version.toString()}")
    }
    onlyname = onlyname.removeSuffix("-boot")
    val unzip = ZipUtil.unzip(bootzip)
    val file = File(unzip, nameandversion)
    val fileexe = File(file, "winsw.exe")
    val filexml = File(file, "winsw.xml")
    FileUtil.writeFromStream(exe, fileexe)
    val replace = xml.replace("ID", "winsw_${nameandversion}")
            .replace("NAME", "winsw_${nameandversion}")
            .replace("DESCRIPTION", "winsw_${nameandversion}")
            .replace("EXECUTABLE", "%BASE%\\bin\\${onlyname}.bat")
    FileUtil.writeUtf8String(replace, filexml)
    val zip = ZipUtil.zip(file)
    project.logger.quiet("ok........................")
    project.logger.quiet(zip.absolutePath)
}
